package com.css.simulation.resource.scheduler.util;

import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.transport.UsernamePasswordCredentialsProvider;

import java.io.File;
import java.util.Objects;

/**
 * <!-- git 操作类库 -->
 * <dependency>
 * <groupId>org.eclipse.jgit</groupId>
 * <artifactId>org.eclipse.jgit</artifactId>
 * <version>${org.eclipse.jgit.version}</version>
 * </dependency>
 */
public class GitUtil {

    public static boolean clone(String url, String username, String password, String localDirectory) throws GitAPIException {
        File localDirectoryObject = new File(localDirectory);
        if (Objects.requireNonNull(localDirectoryObject.listFiles()).length > 0) {
            return false;
        }
        Git git = Git.cloneRepository()
                .setURI(url)
                .setCredentialsProvider(new UsernamePasswordCredentialsProvider(username, password))
                .setDirectory(localDirectoryObject)
                .call();
        return true;
    }
}
